import { NodeInterface, InlinePlugin, PluginOptions } from '@aomao/engine';
import type MarkdownIt from 'markdown-it';
import './index.css';
export interface LinkOptions extends PluginOptions {
    hotkey?: string | Array<string>;
    markdown?: boolean;
    onConfirm?: (text: string, link: string) => Promise<{
        text: string;
        link: string;
    }>;
}
export default class<T extends LinkOptions = LinkOptions> extends InlinePlugin<T> {
    private toolbar?;
    static get pluginName(): string;
    attributes: {
        target: string;
        href: string;
    };
    variable: {
        '@var0': string[];
        '@var1': {
            required: boolean;
            value: string;
        };
    };
    tagName: string;
    init(): void;
    hotkey(): string | string[] | {
        key: string;
        args: string[];
    };
    execute(...args: any): void;
    bindQuery: () => void;
    query: () => boolean | undefined;
    queryState(): boolean | undefined;
    markdownIt: (mardown: MarkdownIt) => void;
    parseHtml: (root: NodeInterface) => void;
    destroy(): void;
}
