'use strict';

var engine = require('@aomao/engine');
var React = require('react');
var ReactDOM = require('react-dom');
var ConfigProvider = require('antd/es/config-provider');
var Input = require('antd/es/input');
var Button = require('antd/es/button');
var classnames = require('classnames-es-ts');
require('antd/es/input/style');
require('antd/es/button/style');
var Tooltip = require('antd/es/tooltip');
require('antd/es/tooltip/style');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var ReactDOM__default = /*#__PURE__*/_interopDefaultLegacy(ReactDOM);
var ConfigProvider__default = /*#__PURE__*/_interopDefaultLegacy(ConfigProvider);
var Input__default = /*#__PURE__*/_interopDefaultLegacy(Input);
var Button__default = /*#__PURE__*/_interopDefaultLegacy(Button);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);
var Tooltip__default = /*#__PURE__*/_interopDefaultLegacy(Tooltip);

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _superPropBase(object, property) {
  while (!Object.prototype.hasOwnProperty.call(object, property)) {
    object = _getPrototypeOf(object);
    if (object === null) break;
  }

  return object;
}

function _get(target, property, receiver) {
  if (typeof Reflect !== "undefined" && Reflect.get) {
    _get = Reflect.get;
  } else {
    _get = function _get(target, property, receiver) {
      var base = _superPropBase(target, property);

      if (!base) return;
      var desc = Object.getOwnPropertyDescriptor(base, property);

      if (desc.get) {
        return desc.get.call(receiver);
      }

      return desc.value;
    };
  }

  return _get(target, property, receiver || target);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var id = 0;

function _classPrivateFieldLooseKey(name) {
  return "__private_" + id++ + "_" + name;
}

function _classPrivateFieldLooseBase(receiver, privateKey) {
  if (!Object.prototype.hasOwnProperty.call(receiver, privateKey)) {
    throw new TypeError("attempted to use private field on non-instance");
  }

  return receiver;
}

var LinkEditor = function LinkEditor(_ref) {
  var language = _ref.language,
      defaultLink = _ref.defaultLink,
      defaultText = _ref.defaultText,
      className = _ref.className,
      onLoad = _ref.onLoad,
      onOk = _ref.onOk;

  var _useState = React.useState(defaultText || ''),
      _useState2 = _slicedToArray(_useState, 2),
      text = _useState2[0],
      setText = _useState2[1];

  var _useState3 = React.useState(defaultLink || ''),
      _useState4 = _slicedToArray(_useState3, 2),
      link = _useState4[0],
      setLink = _useState4[1];

  var linkRef = React.useRef(null);
  React.useEffect(function () {
    var _linkRef$current;

    (_linkRef$current = linkRef.current) === null || _linkRef$current === void 0 ? void 0 : _linkRef$current.focus();
    if (onLoad && linkRef.current) onLoad(linkRef.current);
  }, [linkRef]);
  return /*#__PURE__*/React__default['default'].createElement("div", {
    "data-element": "ui",
    className: classnames__default['default']('data-link-editor', className)
  }, /*#__PURE__*/React__default['default'].createElement("p", null, language.get('link', 'text')), /*#__PURE__*/React__default['default'].createElement("p", null, /*#__PURE__*/React__default['default'].createElement(Input__default['default'], {
    className: "data-link-input",
    value: text,
    placeholder: language.get('link', 'text_placeholder').toString(),
    onChange: function onChange(event) {
      setText(event.target.value);
    }
  })), /*#__PURE__*/React__default['default'].createElement("p", null, language.get('link', 'link')), /*#__PURE__*/React__default['default'].createElement("p", null, /*#__PURE__*/React__default['default'].createElement(Input__default['default'], {
    ref: linkRef,
    className: "data-link-input",
    value: link,
    placeholder: language.get('link', 'link_placeholder').toString(),
    onChange: function onChange(event) {
      setLink(event.target.value);
    }
  })), /*#__PURE__*/React__default['default'].createElement("p", null, /*#__PURE__*/React__default['default'].createElement(Button__default['default'], {
    className: "data-link-button",
    onClick: function onClick() {
      return onOk(text, link);
    },
    disabled: link.trim() === ''
  }, language.get('link', 'ok_button'))));
};

var LinkPreview = function LinkPreview(_ref) {
  var language = _ref.language,
      readonly = _ref.readonly,
      href = _ref.href,
      onEdit = _ref.onEdit,
      onRemove = _ref.onRemove;

  var renderEdit = function renderEdit() {
    var editButton = /*#__PURE__*/React__default['default'].createElement("a", {
      className: "data-icon data-icon-edit",
      onClick: onEdit
    });
    return engine.isMobile ? editButton : /*#__PURE__*/React__default['default'].createElement(Tooltip__default['default'], {
      title: language.get('link', 'link_edit')
    }, editButton);
  };

  var renderRemove = function renderRemove() {
    var removeButton = /*#__PURE__*/React__default['default'].createElement("a", {
      className: "data-icon data-icon-unlink",
      onClick: onRemove
    });
    return engine.isMobile ? removeButton : /*#__PURE__*/React__default['default'].createElement(Tooltip__default['default'], {
      title: language.get('link', 'link_remove')
    }, removeButton);
  };

  return /*#__PURE__*/React__default['default'].createElement("div", {
    className: classnames__default['default']('data-link-preview'),
    "data-element": "ui"
  }, /*#__PURE__*/React__default['default'].createElement(Tooltip__default['default'], {
    title: language.get('link', 'link_open')
  }, /*#__PURE__*/React__default['default'].createElement("a", {
    className: "data-icon data-icon-link data-link-preview-open",
    href: href,
    target: "_blank"
  }, href)), !readonly && /*#__PURE__*/React__default['default'].createElement("div", {
    className: "data-link-op"
  }, renderEdit(), renderRemove()));
};

var _position = /*#__PURE__*/_classPrivateFieldLooseKey("position");

var Toolbar = /*#__PURE__*/function () {
  function Toolbar(engine$1, options) {
    var _this = this;

    _classCallCheck(this, Toolbar);

    this.engine = void 0;
    this.root = void 0;
    this.target = void 0;
    this.options = void 0;
    this.mouseInContainer = false;
    Object.defineProperty(this, _position, {
      writable: true,
      value: void 0
    });
    this.engine = engine$1;
    var change = this.engine.change;
    this.options = options;
    _classPrivateFieldLooseBase(this, _position)[_position] = new engine.Position(this.engine);
    change.event.onWindow('mousedown', function (event) {
      if (!event.target) return;
      var target = engine.$(event.target);
      var container = target.closest('.data-link-container');
      _this.mouseInContainer = container && container.length > 0;
      if (!target.inEditor() && !_this.mouseInContainer) _this.hide();
    });
  }

  _createClass(Toolbar, [{
    key: "create",
    value: function create() {
      var _this$target$get;

      if (!this.target) return;
      var root = engine.$('.data-link-container');

      if (root.length === 0) {
        root = engine.$("<div ".concat(engine.DATA_ELEMENT, "=\"").concat(engine.UI, "\" class=\"data-link-container").concat(engine.isMobile ? ' data-link-container-mobile' : '', "\"></div>"));
      }

      this.root = root;
      var rect = (_this$target$get = this.target.get()) === null || _this$target$get === void 0 ? void 0 : _this$target$get.getBoundingClientRect();
      if (!rect) return;
      this.root.css({
        top: "".concat(window.pageYOffset + rect.bottom + 4, "px"),
        left: "".concat(window.pageXOffset, "px"),
        position: 'absolute',
        'z-index': 125
      });
    }
  }, {
    key: "onOk",
    value: function () {
      var _onOk = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(text, link) {
        var change, range, _ref, onConfirm, result, oldText, _children$eq, children, element, _child$eq, child;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (this.target) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return");

              case 2:
                change = this.engine.change;
                range = change.range.get();

                if (!change.rangePathBeforeCommand) {
                  if (!range.startNode.inEditor()) {
                    range.select(this.target, true);
                    change.range.select(range);
                  }

                  change.cacheRangeBeforeCommand();
                }

                _ref = this.options || {}, onConfirm = _ref.onConfirm;

                if (!onConfirm) {
                  _context.next = 12;
                  break;
                }

                _context.next = 9;
                return onConfirm(text, link);

              case 9:
                result = _context.sent;
                text = result.text;
                link = result.link;

              case 12:
                this.target.attributes('href', link);
                text = text.trim() === '' ? link : text;
                oldText = this.target.text();

                if (!(oldText !== text)) {
                  _context.next = 45;
                  break;
                }

                children = this.target.children(); // 左右两侧有零宽字符

                if (!(children.length < 3)) {
                  _context.next = 21;
                  break;
                }

                this.target.text(text);
                _context.next = 45;
                break;

              case 21:
                if (!(children.length === 3 && ((_children$eq = children.eq(1)) === null || _children$eq === void 0 ? void 0 : _children$eq.isText()))) {
                  _context.next = 25;
                  break;
                }

                this.target.text(text);
                _context.next = 45;
                break;

              case 25:
                if (!(children.length === 3)) {
                  _context.next = 44;
                  break;
                }

                element = children.eq(1);

              case 27:
                if (!element) {
                  _context.next = 42;
                  break;
                }

                child = element.children(); // 有多个子节点就直接设置文本，覆盖里面的mark样式

                if (!(child.length > 1 || child.length === 0)) {
                  _context.next = 34;
                  break;
                }

                element.text(text);
                return _context.abrupt("break", 42);

              case 34:
                if (!((_child$eq = child.eq(0)) === null || _child$eq === void 0 ? void 0 : _child$eq.isText())) {
                  _context.next = 39;
                  break;
                }

                element.text(text);
                return _context.abrupt("break", 42);

              case 39:
                element = child;

              case 40:
                _context.next = 27;
                break;

              case 42:
                _context.next = 45;
                break;

              case 44:
                this.target.text(text);

              case 45:
                this.engine.inline.repairCursor(this.target);
                range.setStart(this.target.next(), 1);
                range.setEnd(this.target.next(), 1);
                change.apply(range);
                this.mouseInContainer = false;
                this.hide();

              case 51:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function onOk(_x, _x2) {
        return _onOk.apply(this, arguments);
      }

      return onOk;
    }()
  }, {
    key: "editor",
    value: function editor(text, href) {
      var _this2 = this;

      return /*#__PURE__*/React__default['default'].createElement(LinkEditor, {
        language: this.engine.language,
        defaultText: text,
        defaultLink: href,
        onLoad: function onLoad() {
          _this2.mouseInContainer = true;

          _this2.engine.trigger('select');
        },
        onOk: function onOk(text, link) {
          return _this2.onOk(text, link);
        }
      });
    }
  }, {
    key: "preview",
    value: function preview(href) {
      var _this3 = this;

      return /*#__PURE__*/React__default['default'].createElement(LinkPreview, {
        language: this.engine.language,
        readonly: this.engine.readonly,
        onEdit: function onEdit() {
          if (!_this3.target) return;
          _this3.mouseInContainer = false;

          _this3.hide(undefined, false);

          _this3.show(_this3.target, true);
        },
        onRemove: function onRemove() {
          if (!_this3.target) return;
          var _this3$engine = _this3.engine,
              change = _this3$engine.change,
              inline = _this3$engine.inline;
          var range = change.range.get();
          range.select(_this3.target, true);
          inline.repairRange(range);
          change.range.select(range);
          change.cacheRangeBeforeCommand();
          inline.unwrap();
          _this3.mouseInContainer = false;
          _this3.target = undefined;

          _this3.hide();
        },
        href: href
      });
    }
  }, {
    key: "show",
    value: function show(target, forceEdit) {
      var _this$target,
          _this$root,
          _this$root$parent,
          _this4 = this;

      if (((_this$target = this.target) === null || _this$target === void 0 ? void 0 : _this$target.equal(target)) && !!((_this$root = this.root) === null || _this$root === void 0 ? void 0 : (_this$root$parent = _this$root.parent()) === null || _this$root$parent === void 0 ? void 0 : _this$root$parent.length)) return;
      this.target = target;
      this.create();
      var text = target.text().replace(/\u200B/g, '');
      var href = target.attributes('href');
      var container = this.root.get();
      ReactDOM__default['default'].render( /*#__PURE__*/React__default['default'].createElement(ConfigProvider__default['default'], {
        autoInsertSpaceInButton: false
      }, (!href || forceEdit) && !this.engine.readonly ? this.editor(text, href) : this.preview(href)), container, function () {
        var _classPrivateFieldLoo, _classPrivateFieldLoo2;

        if (!_this4.root || !_this4.target) return;
        (_classPrivateFieldLoo = _classPrivateFieldLooseBase(_this4, _position)[_position]) === null || _classPrivateFieldLoo === void 0 ? void 0 : _classPrivateFieldLoo.destroy();
        (_classPrivateFieldLoo2 = _classPrivateFieldLooseBase(_this4, _position)[_position]) === null || _classPrivateFieldLoo2 === void 0 ? void 0 : _classPrivateFieldLoo2.bind(_this4.root, _this4.target);
      });
    }
  }, {
    key: "hide",
    value: function hide(target, clearTarget) {
      var _this$root2;

      if (target && this.target && target.equal(this.target)) return;
      var element = (_this$root2 = this.root) === null || _this$root2 === void 0 ? void 0 : _this$root2.get();

      if (element && !this.mouseInContainer) {
        var _classPrivateFieldLoo3;

        ReactDOM__default['default'].unmountComponentAtNode(element);
        (_classPrivateFieldLoo3 = _classPrivateFieldLooseBase(this, _position)[_position]) === null || _classPrivateFieldLoo3 === void 0 ? void 0 : _classPrivateFieldLoo3.destroy();
        this.root = undefined;

        if (this.target && !this.target.attributes('href')) {
          var _this$engine = this.engine,
              change = _this$engine.change,
              inline = _this$engine.inline;
          var range = change.range.get();
          range.select(this.target, true);
          change.range.select(range);
          inline.unwrap();
        }

        if (clearTarget !== false) this.target = undefined;
      }
    }
  }]);

  return Toolbar;
}();

var en = {
  link: {
    text: 'Text',
    link: 'Link',
    text_placeholder: 'Description text',
    link_placeholder: 'Link address',
    link_open: 'Open link',
    link_edit: 'Edit link',
    link_remove: 'Remove link',
    ok_button: 'OK'
  }
};

var cn = {
  link: {
    text: '文本',
    link: '链接',
    text_placeholder: '描述文本',
    link_placeholder: '链接地址',
    link_open: '打开链接',
    link_edit: '编辑链接',
    link_remove: '移除链接',
    ok_button: '确定'
  }
};

var locales = {
  'en-US': en,
  'zh-CN': cn
};

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".data-link-container {\r\n    max-width: 398px;\r\n    display: inline-block;\r\n    border: 1px solid #E8E8E8;\r\n    border-radius: 4px;\r\n    box-shadow: rgba(221, 221, 221, 0.5) 0px 1px 3px;\r\n    background: white;\r\n}\r\n\r\n.data-link-container-mobile {\r\n    max-width: calc(100vw - 20px);;\r\n}\r\n\r\n.data-link-container .data-link-editor {\r\n    min-width: 365px;\r\n    padding: 16px 12px;\r\n    padding-bottom: 4px;\r\n}\r\n\r\n.data-link-container-mobile .data-link-editor {\r\n    min-width: calc(100vw - 40px);\r\n    padding: 8px 6px;\r\n}\r\n\r\n.data-link-container p {\r\n    margin-top: 0;\r\n    margin-bottom: 14px;\r\n}\r\n\r\n.data-link-container .itellyou-icon {\r\n    color: #8590A6;\r\n    font-size: 16px;\r\n}\r\n.data-link-preview {\r\n    line-height: 16px;\r\n    padding: 6px 8px;\r\n    vertical-align: middle;\r\n    white-space: nowrap;\r\n    display: flex;\r\n    justify-content:space-between;\r\n}\r\n.data-link-preview > * {\r\n    display: block;\r\n}\r\n\r\n.data-link-preview a {\r\n    display: inline-block;\r\n    color: #595959;\r\n    margin: 0px 0px 0px 8px;\r\n    padding: 4px;\r\n}\r\n.data-link-preview a:hover {\r\n    background: #F4F4F4;\r\n    cursor: pointer;\r\n}\r\n.data-link-preview a.data-link-preview-open {\r\n    color: #1890FF;\r\n    max-width: 292px;\r\n    overflow: hidden;\r\n    text-overflow: ellipsis;\r\n    white-space: nowrap;\r\n    text-decoration: none;\r\n    font-size: 14px;\r\n    letter-spacing: 1.2px;\r\n    vertical-align: middle;\r\n    margin: 0;\r\n}\r\n.data-link-container-mobile .data-link-preview a.data-link-preview-open {\r\n    max-width: 70%;\r\n}\r\n.data-link-preview a.data-link-preview-open::before\r\n{\r\n    vertical-align: middle;\r\n    margin-right: 2px;\r\n}\r\n\r\n.data-link-preview a.data-link-preview-open:hover{\r\n    background: transparent;\r\n}";
styleInject(css_248z);

var _default = /*#__PURE__*/function (_InlinePlugin) {
  _inherits(_default, _InlinePlugin);

  var _super = _createSuper(_default);

  function _default() {
    var _this;

    _classCallCheck(this, _default);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.toolbar = void 0;
    _this.attributes = {
      target: '@var0',
      href: '@var1'
    };
    _this.variable = {
      '@var0': ['_blank', '_parent', '_top', '_self'],
      '@var1': {
        required: true,
        value: '*'
      }
    };
    _this.tagName = 'a';

    _this.bindQuery = function () {
      _this.query();
    };

    _this.query = function () {
      var _this$toolbar;

      if (!engine.isEngine(_this.editor)) return;
      var change = _this.editor.change;
      var inlineNode = change.inlines.find(function (node) {
        return _this.isSelf(node);
      });
      (_this$toolbar = _this.toolbar) === null || _this$toolbar === void 0 ? void 0 : _this$toolbar.hide(inlineNode);

      if (inlineNode && inlineNode.length > 0 && !inlineNode.isCard()) {
        var range = change.range.get();

        if (range.collapsed || inlineNode.contains(range.startNode) && inlineNode.contains(range.endNode)) {
          var _this$toolbar2;

          (_this$toolbar2 = _this.toolbar) === null || _this$toolbar2 === void 0 ? void 0 : _this$toolbar2.show(inlineNode);
          return true;
        } else {
          var _this$toolbar3;

          (_this$toolbar3 = _this.toolbar) === null || _this$toolbar3 === void 0 ? void 0 : _this$toolbar3.hide();
        }
      }

      return false;
    };

    _this.markdownIt = function (mardown) {
      if (_this.options.markdown !== false) {
        mardown.enable('link');
        mardown.enable('linkify');
      }
    };

    _this.parseHtml = function (root) {
      root.find(_this.tagName).css({
        'font-size': 'inherit',
        padding: '0 2px',
        'line-height': 'inherit',
        'overflow-wrap': 'break-word',
        'text-indent': '0'
      });
    };

    return _this;
  }

  _createClass(_default, [{
    key: "init",
    value: function init() {
      _get(_getPrototypeOf(_default.prototype), "init", this).call(this);

      var editor = this.editor;

      if (engine.isEngine(editor)) {
        this.toolbar = new Toolbar(editor, {
          onConfirm: this.options.onConfirm
        });
        this.editor.on('markdown-it', this.markdownIt);
      }

      editor.on('parse:html', this.parseHtml);
      editor.on('select', this.bindQuery);
      editor.language.add(locales);
    }
  }, {
    key: "hotkey",
    value: function hotkey() {
      return this.options.hotkey || {
        key: 'mod+k',
        args: ['_blank']
      };
    }
  }, {
    key: "execute",
    value: function execute() {
      var _this2 = this;

      if (!engine.isEngine(this.editor)) return;
      var _this$editor = this.editor,
          inline = _this$editor.inline,
          change = _this$editor.change;

      if (!this.queryState()) {
        var inlineNode = engine.$("<".concat(this.tagName, " />"));

        for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        this.setStyle.apply(this, [inlineNode].concat(args));
        this.setAttributes.apply(this, [inlineNode].concat(args));
        var text = args.length > 2 ? args[2] : '';

        if (!!text) {
          inlineNode.text(text);
          inline.insert(inlineNode);
        } else {
          inline.wrap(inlineNode);
        }

        var range = change.range.get();

        if (!range.collapsed && change.inlines.length > 0) {
          var _this$toolbar4;

          (_this$toolbar4 = this.toolbar) === null || _this$toolbar4 === void 0 ? void 0 : _this$toolbar4.show(change.inlines[0]);
        }
      } else {
        var _inlineNode = change.inlines.find(function (node) {
          return _this2.isSelf(node);
        });

        if (_inlineNode && _inlineNode.length > 0) {
          inline.unwrap(_inlineNode);
        }
      }
    }
  }, {
    key: "queryState",
    value: function queryState() {
      return this.query();
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.editor.off('parse:html', this.parseHtml);
      this.editor.off('select', this.bindQuery);
      this.editor.off('markdown-it', this.markdownIt);
    }
  }], [{
    key: "pluginName",
    get: function get() {
      return 'link';
    }
  }]);

  return _default;
}(engine.InlinePlugin);

module.exports = _default;
